import 'dart:async';
import "dart:io";
import "package:generator_plus/generator_plus_cli.dart";
import 'package:generator_plus/src/generator_base.dart';
import 'package:generator_plus/src/generators/init.dart';
import 'package:console/console.dart';

/// The [GeneratorPlus] wrapper class needed for execution
class InitGeneratorPlus extends GeneratorPlus {
  InitGeneratorPlus() {
    addGenerators([new InitGenerator()]);
  }
}

Future main(List<String> arguments) async {
  File generatorPlus = new File("${getPackageRootPath()}tool/generator+.dart");
  if (generatorPlus.existsSync()) {
    Process process;
    List<String> processArgs = [generatorPlus.path];
    processArgs.addAll(arguments);
    int processExitCode;
    try {
      stdin.lineMode = false;
      stdin.echoMode = false;
      process = await Process.start("dart", processArgs,
          workingDirectory: getPackageRootPath(),
          mode: ProcessStartMode.NORMAL,
          includeParentEnvironment: true,
          runInShell: true);
      inheritIO(process, lineBased: false);
      // stdin.listen((List<int> input) {
      //   input.forEach((int code) {
      //     process.stdin.writeCharCode(code);
      //   });
      stdin.listen(process.stdin.add, onDone: process.stdin.close);
      processExitCode = await process.exitCode;
    } finally {
      stdin.lineMode = true;
      stdin.echoMode = true;
      exit(processExitCode);
    }
    // Isolate.spawnUri(isolateCode.uri, arguments, null).then((Isolate isolate) {
    //   //https://www.one-tab.com/page/hOQUh8ovRkKp5xjpp9lC7Q
    // });
  } else {
    generatorPlusCli(new InitGeneratorPlus(), arguments);
  }
}

_stderrCommandExecuter(String data) {
  if (data.codeUnitAt(0) == 5) {
    //'Enquiry' non-printable ASCII code = 5
    switch (data.codeUnitAt(1)) {
      case 1: //'start of heading' non-printable ASCII code = 1
        stdin.echoMode = true;
        stdout.writeln("echoMode on");
        break;
      case 2: //'start of text' non-printable ASCII code = 2
        stdin.lineMode = true;
        stdout.writeln("lineMode on");
        break;
      case 3: //'end of text' non-printable ASCII code = 3
        stdout.writeln("echoMode off");
        stdin.echoMode = false;
        break;
      case 4: //'end of transmission' non-printable ASCII code = 4
        stdin.lineMode = false;
        stdout.writeln("lineMode off");
        break;
      case 5:
      // stdout.writeCharCode(stdin.readByteSync());
    }
  }
}
