// Copyright (c) 2017, Rodsevich. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.
import 'dart:io';
import 'package:generator_plus/src/generators/utils/variables_resolver.dart';
import 'package:logging/logging.dart';

import './src/generator_base.dart';
import './src/cli/generator_runner.dart';
import "./src/cli/interactions/base.dart"
    show CLIInteractionsHandler, CLInterface;

// import 'package:stack_trace/stack_trace.dart';

export "./src/cli/interactions/base.dart" show CLInterface;
export "./src/common.dart" show getPackageRootPath;

/// The processing starting point, this presupposes that the `dart:io` library
/// will be used
void generatorPlusCli(GeneratorPlus implementation, List<String> args) {
  CLInterface iface = new CLInterface(stdin, stdout, stderr);
  CLIInteractionsHandler cliInteractionsHandler =
      new CLIInteractionsHandler(iface);
  Logger logger = new Logger("");
  VariablesResolver variablesResolver = new VariablesResolver();
  CLIGeneratorPlusRunner runner = new CLIGeneratorPlusRunner(
      implementation, iface, cliInteractionsHandler, logger, variablesResolver);
  // Chain.capture(() {
  runner.run(args).then((_) {
    exit(0);
  }).catchError((e) {
    throw e;
    exit(1);
  });
}
