import "../../interactions/base.dart";
import "./base.dart";
import 'dart:async';
import 'package:console/console.dart';

class CLIConfirmationInteraction extends ConfirmationInteraction
    with CLIUtilsMixin {
  CLIConfirmationInteraction(
      CLInterface clInterface, String message, bool defaultValue)
      : super(clInterface, message, defaultValue) {
    if (this.ioInterface == null) {
      this.ioInterface = clInterface;
    }
  }

  Future<bool> execution() async {
    message = message.trim();
    if (message.endsWith("?") == false) message += '?';
    String hints = "(";
    hints += (defaultValue == true) ? 'Y/n)' : 'y/N)';
    clInterface.print("$message $hints");
    await for (List<int> inputCharCodes in clInterface.charCode) {
      if (inputCharCodes.first == 10) {
        //enter
        return confirmation();
      }
      String char = new String.fromCharCodes(inputCharCodes);
      if (char.toUpperCase() == "Y") {
        return confirmation();
      }
      if (char.toUpperCase() == "N") {
        return negation();
      }
    }
  }

  bool confirmation() {
    String checkmark =
        format("{color.green}${Icon.HEAVY_CHECKMARK}{color.normal}");
    Console.overwriteLine("$message $checkmark\n");
    return true;
  }

  bool negation() {
    String cross = format("{color.red}${Icon.HEAVY_BALLOT_X}{color.normal}");
    Console.overwriteLine("$message $cross\n");
    return false;
  }
}
