import 'dart:async';
import '../generation/dependency.dart';
import '../common.dart';
import 'base.dart';

/// The Generator that will scaffold a Generator+ workspace for the package
class InitGenerator extends Generator {
  String get name => "init";

  String get description => "Initialize a project workspace for Generator+";

  List<Dependency> get alwaysNeededDependencies =>
      [new Dependency("generator_plus", "any", isDevDependency: true)];

  OverridingPolicy get overridePolicy => OverridingPolicy.NEVER;

  Map get startingVariables => {"packageName": getThisPackageName()};

  Future execution() async {
    logger.info("Initializing generator+ for ${variablesResolver["packageName"]}");
    // variablesResolver["packageName"] = getThisPackageName();
    await generateTemplateDir("package:generator_plus/src/templates/init");
  }
}
