import 'dart:async';
import 'dart:io';
import 'dart:isolate';
import 'dart:mirrors';
import 'package:console/console.dart';
import 'package:mustache/mustache.dart';
import "package:generator_plus/src/generators/utils/sequencer.dart";
import "package:generator_plus/src/common.dart";
import 'package:recase/recase.dart';
// import "package:resource/resource.dart";

main(List args) {
  nonPrintableASCII(args);
}

nonPrintableASCII(List args) {
  String s = "\x05\x01hola";
  print("$s: ${s.codeUnits}");
}

void reCaseMirror(arg) {
  ReCase recase = new ReCase(arg);
  InstanceMirror mirror = reflect(recase);
  print(mirror.getField(#pascalCase).reflectee);
}

void probarRegExp(List args) {
  args.forEach((arg) {
    _split_variables(arg);
    print("--------------------------------");
  });
}

void _split_variables(String request) {
  RegExp casingAnalyzer = new RegExp(r"([A-Za-z0-9]+)_?([A-Za-z]*)?");
  Match match = casingAnalyzer.firstMatch(request);
  String varName = match.group(1);
  String recase = match.group(2);
  print("varName: $varName");
  print("recase: $recase");
}

Future tirar_un_kdialog() async {
  Process p = await Process.start("bash", ["/tmp/out.sh"],
      runInShell: true, mode: ProcessStartMode.DETACHED);
  int pid = p.pid;
  print("Ejecutando con pid: $pid");
}

resolver_desde_packages() {
  String packageName = "generator_plus";
  File pubPackages = new File("${getPackageRootPath()}.packages");
  String packages = pubPackages.readAsStringSync();
  RegExp match = new RegExp("$packageName:file:\/\/(.*)");
  String packagePath = match.firstMatch(packages)?.group(1);
  Directory package = new Directory(packagePath ?? "");
  if (package.existsSync())
    package.listSync().forEach((e) {
      print(e.path);
    });
}

map_como_lista() {
  Map<int, String> map = {};
  map[2] = "sorp";
  map[45] = "longa";
  print(map);
}

procesa_partials() {
  Template t = new Template("genero: {{ > generator }}",
      partialResolver: partialsResolver);
  print(t.renderString(
      {"name": "gen", "description": "desc", "override_policy": "ASK"}));
}

resolver() async {
  // Resource r = new Resource("package:resource/resource.dart");
  Uri uri = await Isolate
      .resolvePackageUri(Uri.parse("package:resource/resource.dart"));
  print(uri.normalizePath());
  print(uri.path);
  // r.readAsString().then(print);
  // File f = new File(r.uri.toFilePath());
  // print(f.readAsStringSync());
  // r = new Resource("package:generator_plus/src/templates/init");
  // Directory d = new Directory(r.uri.toFilePath());
  // d.listSync().forEach((FileSystemEntity e) {
  //   print(e.toString());
  // });
}

lists_arent_equals() {
  print([1] == [1]);
  // String input = "1q2";
  // RegExp re = new RegExp("[0-9]");
  // print(re.allMatches(input));
}

pruebas_con_borrado_lineas_con_enter() {
  int i;
  for (i = 0; i < 10; i++) {
    print("deleteame $i");
  }
  Keyboard.echoUnhandledKeys = false;
  Keyboard.bindKey("\n").listen((_) {
    if (--i == 0) exit(0);
    Console.moveCursorUp();
    Console.eraseLine();
  });
}

print_keyCodes_until_enter() {
  while (true) {
    stdin.echoMode = false;
    int n = stdin.readByteSync();
    if (n == 10) exit(0);
    print(n);
  }
}

catchear_errores() {
  uno().then((_) {
    print("todo bien");
  }, onError: (e) {
    print("cace el error $e");
  });
}

ver_future_value() {
  String sorpi = "sorpi";
  new Future.value(sorpi).then((_) => print(_));
}

Future uno() {
  Completer c = new Completer();
  dos().then((_) {
    c.complete("listo");
  }, onError: (e) {
    c.completeError(e);
  });
  return c.future;
}

Future dos() {
  Completer c = new Completer();
  tres().then((_) {
    c.complete("listo");
  }, onError: (e) {
    c.completeError(e);
  });
  return c.future;
}

Future tres() {
  Completer c = new Completer();
  cuatro().then((_) {
    c.complete("listo");
  }, onError: (e) {
    c.completeError(e);
  });
  return c.future;
}

Future cuatro() {
  Completer c = new Completer();
  new Future.microtask(() {
    try {
      throwea();
      c.complete("termino sin throw");
    } catch (e) {
      c.completeError("throweo");
    }
  });
  return c.future;
}

void throwea() {
  new Future.delayed(new Duration(seconds: 2), () {
    throw new StateError("sorpi");
  }).catchError((e) {
    print("error catcheado");
  });
}

@proxy
class Longa {
  String dos = "2";
}

eventual_property() {
  Longa longa = new Longa();
  String numero;
  try {
    numero = longa.numero;
  } on NoSuchMethodError catch (e) {
    numero = longa.dos;
  }
  print(numero);
}

inserts() {
  List nums = [0, 1, 2, 3];
  nums.insert(4, 999);
  print(nums);
}

trackingFuture() {
  TrackingCompleter completer = new TrackingCompleter();
  TrackingFuture future = completer.future;
  print("isAwaited: ${future.isAwaited} (F)");
  new Future.delayed(new Duration(milliseconds: 500), () {
    future.then((_) {
      print("executing sorping");
      print("isThenExecuted: ${future.isThenExecuted} (F)");
      new Future.delayed(new Duration(milliseconds: 500), () {
        print("isThenExecuted: ${future.isThenExecuted} (T)");
        exit(0);
      });
    });
    future.whenComplete(() => print("whenComplete"));
    print("isAwaited: ${future.isAwaited} (T)");
    print("isThenExecuted: ${future.isThenExecuted} (F)");
    completer.complete();
  });
  new Timer(new Duration(seconds: 2), () {
    stderr.writeln("no salió bien");
    exit(1);
  });
}
